<!DOCTYPE html>
<html>

<head>
    <title>INF226</title>
    <link rel="stylesheet" href="/static/indexStyle.css" />
	<link rel="icon" href="favicon.png" type="image/png" />


</head>

<body>
    <div id="page">
        <marquee>
            <div id="header"></div>
        </marquee>
        <main>
            <pre id="output"></pre>
        </main>
        <div id="controls">
            <label for="search">Search:</label>
            <input type="search" id="search" name="search" enterkeyhint="search" value="*">
            <button type="button" id="searchBtn">Search!</button>
            <button type="button" id="allBtn">Show all</button>
            <button type ="button" id="myConvos"> My conversations</button>
            <button type = "button" id ="newConvo">New conversation</button>
            <label for="sender">From:</label>
            <input type ="text" id ="convoID" name="convoID" value="convoID">
        <!--    <input type="text" id="sender" name="sender" value="Alice"> -->
            <button type="button" id="sendBtn">Send</button>
            <a href="/logout"><button>Log out<span class="material-symbols-outlined"></span></button></a>
            <!-- <span></span> -->
            
            <textarea id="message" class="msgBox"style="grid-row: span 4;">A message...</textarea>
        </div>
        <div id="anchor"></div>
    </div>
</body>
<script>
    var reqId = 0;
    var anchor = document.getElementById('anchor');
    var searchField = document.getElementById('search');
    var senderField = document.getElementById('sender');
    var convoID = document.getElementById('convoID');
    var messageField = document.getElementById('message');
    var searchBtn = document.getElementById('searchBtn');
    var sendBtn = document.getElementById('sendBtn');
    var allBtn = document.getElementById('allBtn');
    var myConvos = document.getElementById('myConvos');
    var newConvo = document.getElementById('newConvo');
    var output = document.getElementById('output');
    var header = document.getElementById('header');

    var checkAnnouncements = async () => {
        res = await fetch('/announcements');
        anns = await res.json();
        if (anns && Array.isArray(anns.data)) {
            const elts = [];
            anns.data.forEach((element, idx) => {
                if (idx > 0) {
                    const node = document.createElement('li');
                    node.textContent = '  …  ';
                    elts.push(node);
                }
                const node = document.createElement('li');
                node.textContent = `${element.message || ''}`;
                elts.push(node);
            });
            console.log(elts);
            header.replaceChildren(...elts);
        }
    };
    var search = async (query) => {
        console.log(csrfToken)
        const id = reqId++;
        const q = `/search?q=${encodeURIComponent(query)}`;
        res = await fetch(q);
        console.log(res);
        const head = document.createElement('h3');
        head.textContent = `[${id}]  ${q} → ${res.status} ${res.statusText}`;
        output.appendChild(head);
        const body = document.createElement('p');
        body.innerHTML = await res.text();
        output.appendChild(body);
        body.scrollIntoView({block: "end", inline: "nearest", behavior: "smooth"});
        anchor.scrollIntoView();
        checkAnnouncements();
    };
    var send = async (sender, message) => {
        const id = reqId++;
        const q = `/send?sender=${encodeURIComponent(sender)}&message=${encodeURIComponent(message)}`;
        res = await fetch(q, { method: 'post', headers: { "X-CSRFToken": csrfToken}});
        console.log(res);
        const head = document.createElement('h3');
        head.textContent = `[${id}]  ${q} → ${res.status} ${res.statusText}`;
        output.appendChild(head);
        const body = document.createElement('p');
        body.innerHTML = await res.text();
        output.appendChild(body);
        body.scrollIntoView({block: "end", inline: "nearest", behavior: "smooth"});
        anchor.scrollIntoView();
        checkAnnouncements();
    };

    var getConvos = async () => {
        const id = reqId++;
        const q = '/mychats';
        console.log('test');
        res = await fetch(q);
        console.log(res);
        const head = document.createElement('h3');
        head.textContent = `[${id}]  ${q} → ${res.status} ${res.statusText}`;
        output.appendChild(head);
        const body = document.createElement('p');
        body.innerHTML = await res.text();
        output.appendChild(body);
        body.scrollIntoView({block: "end", inline: "nearest", behavior: "smooth"});
        anchor.scrollIntoView();
        checkAnnouncements();
    }

    var newConvo = async (name, users) => {
        const id = reqId++;
        const q = '/newchat?chatname=${encodeURIComponent(name)}&users=${encodeURIComponent(users)}';
        res = await fetch(q, {method: 'post', headers: { "X-CSRFToken": csrfToken}});
        console.log(res);
    }
    searchField.addEventListener('keydown', ev => {
        if (ev.key === 'Enter') {
            search(searchField.value, convoID.value);
        }
    });
    searchBtn.addEventListener('click', () => search(searchField.value, convoID.value));
    allBtn.addEventListener('click', () => search('*', ''));
    sendBtn.addEventListener('click', () => send(convoID.value, messageField.value));
    myConvos.addEventListener('click', () => getConvos());
    newConvo.addEventListener('click', () => newConvo(searchField.value, messageField.value));
    checkAnnouncements();

</script>

</html>